﻿// JRMC Html Automation Display View
// v1.1 - 02/04/14 by cncb

// Global variables
var jrmc = null;
var gPos = 0;
var gCurKey = -1;
var gCurHeight = 0;


function init(MCAuto)
{
    // Main JRMC automation object
    jrmc = MCAuto;
    
    // Set up borders
    document.body.style.padding = BORDER_PERCENT + "%";
    CONTENT.style.width = (100 - SHIFT_PERCENT) + "%";
    CONTENT.style.height = (100 - SHIFT_PERCENT) + "%";

    // Update and movement timers
    MAIN.timer = setInterval(pollMC, 1000);
    if (SHIFT_FREQ > 0 && SHIFT_PERCENT > 0)
        CONTENT.timer = setInterval(ShiftDisplay, SHIFT_FREQ * 1000);
}

function ScaleText()
{
    if (DESIGN_HEIGHT > 0)
    {
        var factor = gCurHeight / DESIGN_HEIGHT;
        TOPHEADER.style.fontSize = factor * HEADER_FONT;
        CURRENT.style.fontSize = factor * CURRENT_FONT;
        PROGTEXT.style.fontSize = factor * PROGRESS_FONT;
        NEXT.style.fontSize = factor * NEXT_FONT;
    }
}

function FillFileInfo(file)
{
    TEXT.innerHTML = file.GetFilledTemplate(CURRENT_EXP);
    COVER.src = file.GetImageFile(5);
    COUNT.innerText = (jrmc.GetCurPlaylist().Position + 1) + " of " + jrmc.GetCurPlaylist().GetNumberFiles();

    var nextFile = jrmc.GetCurPlaylist().GetFile(jrmc.GetCurPlaylist().GetNextFile());
    if (nextFile != null)
    {
        NEXT.style.visibility = "visible";
        COVERNEXT.src = nextFile.GetImageFile(5);
        TEXTNEXT.innerHTML = nextFile.GetFilledTemplate(NEXT_EXP);
    }
    else
        NEXT.style.visibility = "hidden";
}

// Poll MC for its state every second.
function pollMC() {

    if (jrmc == null)
        return;

    try
    {
        var state = jrmc.GetPlayback().State;
        switch (state) {
            case 0: // stopped
                {
                    TELAPSED.style.width = "0%";
                    break;
                }
            case 1: // paused
                {
                    break;
                }
            case 2: // playing
                {
                    // Update playback time and progress
		    var dur = jrmc.GetPlayback().Duration;
		    var pos = jrmc.GetPlayback().Position;
		    if( dur > 0)
		    {
                      var timeremain = dur - pos;
                      var percent = (pos / dur) * 100;
                      TELAPSED.style.width = percent + "%";
                      PROGTEXT.innerText = " -" + FormatTime(timeremain) + " / " + FormatTime(dur);
		    }
                    break;
                }
        }

        // Time-of-day
        var timestr = new Date().toLocaleTimeString();
        var index = timestr.lastIndexOf(':');
        if (index > 0)
            timestr = timestr.substring(0, index) + timestr.substring(index + 3);
        TIME.innerText = timestr;

        // Check for resize to scale fonts
        if (DESIGN_HEIGHT > 0 && MAIN.offsetHeight != gCurHeight)
        {
            gCurHeight = MAIN.offsetHeight;
            ScaleText();
        }

        // Check if current file has changed
        var file = jrmc.GetCurPlaylist().GetFile(jrmc.GetCurPlaylist().Position);
        if (file != null && file.GetKey() != gCurKey)
        {
            gCurKey = file.GetKey();
            FillFileInfo(file);
        }


    }
    catch (err)
    {
        TEXT.innerHTML = err;
    }
}

function ShiftDisplay()
{
    if (gPos < (2*SHIFT_PERCENT+1))
        gPos = gPos + 1;
    else
        gPos = 0;

    CONTENT.style.left = (gPos > SHIFT_PERCENT ? ((2*SHIFT_PERCENT+1) - gPos) : gPos) + "%";
    CONTENT.style.top = (gPos > SHIFT_PERCENT ? (gPos - (SHIFT_PERCENT+1)) : gPos) + "%";
}

function FormatTime( time)
{
 	var str = parseInt(time/60) + ":";
 	var sec = time % 60;
 	if( sec < 10)
 	    str += "0" + sec;
 	else
 	    str += sec;
    return str;
}